function el(theId) {
    return document.getElementById(theId);
}

/*********************************************************************
	mixes up n elements of nArray starting at element startAt
**********************************************************************/
function shuffle( nArray, startAt, n )
{
    var i, j, swap;
    
    for (i = startAt; i < startAt + n; i++)
    {
        j = startAt + Math.round(Math.random() * (n - 1));
        swap = nArray[i];
        nArray[i] = nArray[j];
        nArray[j] = swap;
    }
}

function showGreek(id, str) {
    el(id).innerHTML = str;
}

var prob;
var maxProb;
var nTries;
var answered;
var nCorrect;
var order;
var correctWord;
var congrat = new Array("Yes, that's it.", "Correct.", "That's right.", "Very good.",
                        "You got it right.", "Excellent.", "Good work.");

function showAnswer()
{
    if (answered)
    {
        // nextProblem();
        el("feedback").innerHTML =
            "Click <em>Next Problem</em> to continue.";
    }
    else 
    {
        showGreek("correct", correctWord[0]);
    }

    answered = true;
}

function entered()
{
    var i;
    var student;
    var ok;
    var feedback = el("feedback");
    var feedbackPic = el("feedbackPic");

    if (answered)
    {
        /*feedback.innerHTML =
            "Click <em>Next Problem</em> to continue.";*/
        nextProblem();
    }
    else
    {

        ok = false;
        student = el("greek").value;

        for (let i = 0; i < correctWord.length && !ok; i++) {
            ok = (student == correctWord[i]);
        }
        
        if (ok)
        {
            answered = true;
            feedback.innerHTML =
                congrat[Math.floor(Math.random() * 4)];
            feedbackPic.src = "../pics/ok3.png";
            feedbackPic.alt = "OK";
            if (nTries == 0)
            {
                nCorrect++;
                el("nCorrect").innerHTML = nCorrect;
            }
        }
        else
        {
            feedbackPic.src = "../pics/bad3.png";
            feedbackPic.alt = "no";
            nTries++;
            if (nTries == 2)
            {
                feedback.innerHTML =
                    "The correct answer is shown above.";
                showAnswer();
            }
            else
            {
                feedback.innerHTML =
                    "Sorry, that’s not it. Please try again.";
            }
        }
    }
}

function nextProblem()
{
    prob++;
    nTries = 0;
    answered = false;
    if (prob >= maxProb)
    {
        top.location.href = nextPageURL;    
    }
    else
    {
        el("feedbackPic").src = "../pics/mt3.png";
        el("prob").innerHTML = prob + 1;
        el("english").innerHTML = engWord[order[prob]];
        el("feedback").innerHTML = "";
        clearInput('');
        correctWord = greekWord[order[prob]].split("/" );
        showGreek("correct", '&nbsp;');
        refocus();
    }
}

function startExercise()
{
    setInput("greek");
    prob = -1;
    nCorrect = 0;
    maxProb = engWord.length;
    el("maxProb").innerText = maxProb;
    el("nCorrect").innerText = 0;
    order = new Array(maxProb);
    for (let i = 0; i < maxProb; i++)
    {
        order[i] = i;
    }
    shuffle(order, 0, maxProb);
    nextProblem();
}

function clearText(id) {
    document.getElementById(id).innerText = '';
}

function setText(id, str) {
    document.getElementById(id).innerText = str;
}

function setHTML(id, str) {
    document.getElementById(id).innerHTML = str;
}
